<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>QuorumPeerConfig.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">QuorumPeerConfig.java</span></div><h1>QuorumPeerConfig.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;
import java.util.Map.Entry;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.slf4j.MDC;

import org.apache.zookeeper.server.ZooKeeperServer;
import org.apache.zookeeper.server.quorum.QuorumPeer.LearnerType;
import org.apache.zookeeper.server.quorum.QuorumPeer.QuorumServer;
import org.apache.zookeeper.server.quorum.flexible.QuorumHierarchical;
import org.apache.zookeeper.server.quorum.flexible.QuorumMaj;
import org.apache.zookeeper.server.quorum.flexible.QuorumVerifier;

<span class="fc" id="L45">public class QuorumPeerConfig {</span>
<span class="fc" id="L46">    private static final Logger LOG = LoggerFactory.getLogger(QuorumPeerConfig.class);</span>

    protected InetSocketAddress clientPortAddress;
    protected String dataDir;
    protected String dataLogDir;
<span class="fc" id="L51">    protected int tickTime = ZooKeeperServer.DEFAULT_TICK_TIME;</span>
<span class="fc" id="L52">    protected int maxClientCnxns = 60;</span>
    /** defaults to -1 if not set explicitly */
<span class="fc" id="L54">    protected int minSessionTimeout = -1;</span>
    /** defaults to -1 if not set explicitly */
<span class="fc" id="L56">    protected int maxSessionTimeout = -1;</span>

    protected int initLimit;
    protected int syncLimit;
<span class="fc" id="L60">    protected int electionAlg = 3;</span>
<span class="fc" id="L61">    protected int electionPort = 2182;</span>
<span class="fc" id="L62">    protected boolean quorumListenOnAllIPs = false;</span>
<span class="fc" id="L63">    protected final HashMap&lt;Long,QuorumServer&gt; servers =</span>
        new HashMap&lt;Long, QuorumServer&gt;();
<span class="fc" id="L65">    protected final HashMap&lt;Long,QuorumServer&gt; observers =</span>
        new HashMap&lt;Long, QuorumServer&gt;();

    protected long serverId;
<span class="fc" id="L69">    protected HashMap&lt;Long, Long&gt; serverWeight = new HashMap&lt;Long, Long&gt;();</span>
<span class="fc" id="L70">    protected HashMap&lt;Long, Long&gt; serverGroup = new HashMap&lt;Long, Long&gt;();</span>
<span class="fc" id="L71">    protected int numGroups = 0;</span>
    protected QuorumVerifier quorumVerifier;
<span class="fc" id="L73">    protected int snapRetainCount = 3;</span>
<span class="fc" id="L74">    protected int purgeInterval = 0;</span>
<span class="fc" id="L75">    protected boolean syncEnabled = true;</span>

<span class="fc" id="L77">    protected LearnerType peerType = LearnerType.PARTICIPANT;</span>
    
    /**
     * Minimum snapshot retain count.
     * @see org.apache.zookeeper.server.PurgeTxnLog#purge(File, File, int)
     */
<span class="fc" id="L83">    private final int MIN_SNAP_RETAIN_COUNT = 3;</span>

<span class="fc" id="L85">    @SuppressWarnings(&quot;serial&quot;)</span>
    public static class ConfigException extends Exception {
        public ConfigException(String msg) {
<span class="nc" id="L88">            super(msg);</span>
<span class="nc" id="L89">        }</span>
        public ConfigException(String msg, Exception e) {
<span class="fc" id="L91">            super(msg, e);</span>
<span class="fc" id="L92">        }</span>
    }

    /**
     * Parse a ZooKeeper configuration file
     * @param path the patch of the configuration file
     * @throws ConfigException error processing configuration
     */
    public void parse(String path) throws ConfigException {
<span class="fc" id="L101">        File configFile = new File(path);</span>

<span class="fc" id="L103">        LOG.info(&quot;Reading configuration from: &quot; + configFile);</span>

        try {
<span class="pc bpc" id="L106" title="1 of 2 branches missed.">            if (!configFile.exists()) {</span>
<span class="nc" id="L107">                throw new IllegalArgumentException(configFile.toString()</span>
                        + &quot; file is missing&quot;);
            }

<span class="fc" id="L111">            Properties cfg = new Properties();</span>
<span class="fc" id="L112">            FileInputStream in = new FileInputStream(configFile);</span>
            try {
<span class="fc" id="L114">                cfg.load(in);</span>
<span class="fc" id="L115">            } finally {</span>
<span class="nc" id="L116">                in.close();</span>
<span class="fc" id="L117">            }</span>

<span class="fc" id="L119">            parseProperties(cfg);</span>
<span class="nc" id="L120">        } catch (IOException e) {</span>
<span class="nc" id="L121">            throw new ConfigException(&quot;Error processing &quot; + path, e);</span>
<span class="fc" id="L122">        } catch (IllegalArgumentException e) {</span>
<span class="fc" id="L123">            throw new ConfigException(&quot;Error processing &quot; + path, e);</span>
<span class="fc" id="L124">        }</span>
<span class="pc" id="L125">    }</span>

    /**
     * Parse config from a Properties.
     * @param zkProp Properties to parse from.
     * @throws IOException
     * @throws ConfigException
     */
    public void parseProperties(Properties zkProp)
    throws IOException, ConfigException {
<span class="fc" id="L135">        int clientPort = 0;</span>
<span class="fc" id="L136">        String clientPortAddress = null;</span>
<span class="fc bfc" id="L137" title="All 2 branches covered.">        for (Entry&lt;Object, Object&gt; entry : zkProp.entrySet()) {</span>
<span class="fc" id="L138">            String key = entry.getKey().toString().trim();</span>
<span class="fc" id="L139">            String value = entry.getValue().toString().trim();</span>
<span class="fc bfc" id="L140" title="All 2 branches covered.">            if (key.equals(&quot;dataDir&quot;)) {</span>
<span class="fc" id="L141">                dataDir = value;</span>
<span class="fc bfc" id="L142" title="All 2 branches covered.">            } else if (key.equals(&quot;dataLogDir&quot;)) {</span>
<span class="fc" id="L143">                dataLogDir = value;</span>
<span class="fc bfc" id="L144" title="All 2 branches covered.">            } else if (key.equals(&quot;clientPort&quot;)) {</span>
<span class="fc" id="L145">                clientPort = Integer.parseInt(value);</span>
<span class="pc bpc" id="L146" title="1 of 2 branches missed.">            } else if (key.equals(&quot;clientPortAddress&quot;)) {</span>
<span class="nc" id="L147">                clientPortAddress = value.trim();</span>
<span class="fc bfc" id="L148" title="All 2 branches covered.">            } else if (key.equals(&quot;tickTime&quot;)) {</span>
<span class="fc" id="L149">                tickTime = Integer.parseInt(value);</span>
<span class="pc bpc" id="L150" title="1 of 2 branches missed.">            } else if (key.equals(&quot;maxClientCnxns&quot;)) {</span>
<span class="nc" id="L151">                maxClientCnxns = Integer.parseInt(value);</span>
<span class="pc bpc" id="L152" title="1 of 2 branches missed.">            } else if (key.equals(&quot;minSessionTimeout&quot;)) {</span>
<span class="nc" id="L153">                minSessionTimeout = Integer.parseInt(value);</span>
<span class="pc bpc" id="L154" title="1 of 2 branches missed.">            } else if (key.equals(&quot;maxSessionTimeout&quot;)) {</span>
<span class="nc" id="L155">                maxSessionTimeout = Integer.parseInt(value);</span>
<span class="fc bfc" id="L156" title="All 2 branches covered.">            } else if (key.equals(&quot;initLimit&quot;)) {</span>
<span class="fc" id="L157">                initLimit = Integer.parseInt(value);</span>
<span class="fc bfc" id="L158" title="All 2 branches covered.">            } else if (key.equals(&quot;syncLimit&quot;)) {</span>
<span class="fc" id="L159">                syncLimit = Integer.parseInt(value);</span>
<span class="fc bfc" id="L160" title="All 2 branches covered.">            } else if (key.equals(&quot;electionAlg&quot;)) {</span>
<span class="fc" id="L161">                electionAlg = Integer.parseInt(value);</span>
<span class="pc bpc" id="L162" title="1 of 2 branches missed.">            } else if (key.equals(&quot;quorumListenOnAllIPs&quot;)) {</span>
<span class="nc" id="L163">                quorumListenOnAllIPs = Boolean.parseBoolean(value);</span>
<span class="fc bfc" id="L164" title="All 2 branches covered.">            } else if (key.equals(&quot;peerType&quot;)) {</span>
<span class="pc bpc" id="L165" title="1 of 2 branches missed.">                if (value.toLowerCase().equals(&quot;observer&quot;)) {</span>
<span class="fc" id="L166">                    peerType = LearnerType.OBSERVER;</span>
<span class="nc bnc" id="L167" title="All 2 branches missed.">                } else if (value.toLowerCase().equals(&quot;participant&quot;)) {</span>
<span class="nc" id="L168">                    peerType = LearnerType.PARTICIPANT;</span>
                } else
                {
<span class="nc" id="L171">                    throw new ConfigException(&quot;Unrecognised peertype: &quot; + value);</span>
                }
<span class="pc bpc" id="L173" title="1 of 2 branches missed.">            } else if (key.equals( &quot;syncEnabled&quot; )) {</span>
<span class="nc" id="L174">                syncEnabled = Boolean.parseBoolean(value);</span>
<span class="pc bpc" id="L175" title="1 of 2 branches missed.">            } else if (key.equals(&quot;autopurge.snapRetainCount&quot;)) {</span>
<span class="nc" id="L176">                snapRetainCount = Integer.parseInt(value);</span>
<span class="pc bpc" id="L177" title="1 of 2 branches missed.">            } else if (key.equals(&quot;autopurge.purgeInterval&quot;)) {</span>
<span class="nc" id="L178">                purgeInterval = Integer.parseInt(value);</span>
<span class="fc bfc" id="L179" title="All 2 branches covered.">            } else if (key.startsWith(&quot;server.&quot;)) {</span>
<span class="fc" id="L180">                int dot = key.indexOf('.');</span>
<span class="fc" id="L181">                long sid = Long.parseLong(key.substring(dot + 1));</span>
<span class="fc" id="L182">                String parts[] = value.split(&quot;:&quot;);</span>
<span class="pc bpc" id="L183" title="2 of 6 branches missed.">                if ((parts.length != 2) &amp;&amp; (parts.length != 3) &amp;&amp; (parts.length !=4)) {</span>
<span class="nc" id="L184">                    LOG.error(value</span>
                       + &quot; does not have the form host:port or host:port:port &quot; +
                       &quot; or host:port:port:type&quot;);
                }
<span class="fc" id="L188">                LearnerType type = null;</span>
<span class="fc" id="L189">                String hostname = parts[0];</span>
<span class="fc" id="L190">                Integer port = Integer.parseInt(parts[1]);</span>
<span class="fc" id="L191">                Integer electionPort = null;</span>
<span class="pc bpc" id="L192" title="1 of 2 branches missed.">                if (parts.length &gt; 2){</span>
<span class="fc" id="L193">                	electionPort=Integer.parseInt(parts[2]);</span>
                }
<span class="fc bfc" id="L195" title="All 2 branches covered.">                if (parts.length &gt; 3){</span>
<span class="pc bpc" id="L196" title="1 of 2 branches missed.">                    if (parts[3].toLowerCase().equals(&quot;observer&quot;)) {</span>
<span class="fc" id="L197">                        type = LearnerType.OBSERVER;</span>
<span class="nc bnc" id="L198" title="All 2 branches missed.">                    } else if (parts[3].toLowerCase().equals(&quot;participant&quot;)) {</span>
<span class="nc" id="L199">                        type = LearnerType.PARTICIPANT;</span>
                    } else {
<span class="nc" id="L201">                        throw new ConfigException(&quot;Unrecognised peertype: &quot; + value);</span>
                    }
                }
<span class="fc bfc" id="L204" title="All 2 branches covered.">                if (type == LearnerType.OBSERVER){</span>
<span class="fc" id="L205">                    observers.put(Long.valueOf(sid), new QuorumServer(sid, hostname, port, electionPort, type));</span>
                } else {
<span class="fc" id="L207">                    servers.put(Long.valueOf(sid), new QuorumServer(sid, hostname, port, electionPort, type));</span>
                }
<span class="pc bpc" id="L209" title="1 of 2 branches missed.">            } else if (key.startsWith(&quot;group&quot;)) {</span>
<span class="nc" id="L210">                int dot = key.indexOf('.');</span>
<span class="nc" id="L211">                long gid = Long.parseLong(key.substring(dot + 1));</span>

<span class="nc" id="L213">                numGroups++;</span>

<span class="nc" id="L215">                String parts[] = value.split(&quot;:&quot;);</span>
<span class="nc bnc" id="L216" title="All 2 branches missed.">                for(String s : parts){</span>
<span class="nc" id="L217">                    long sid = Long.parseLong(s);</span>
<span class="nc bnc" id="L218" title="All 2 branches missed.">                    if(serverGroup.containsKey(sid))</span>
<span class="nc" id="L219">                        throw new ConfigException(&quot;Server &quot; + sid + &quot;is in multiple groups&quot;);</span>
                    else
<span class="nc" id="L221">                        serverGroup.put(sid, gid);</span>
                }

<span class="pc bpc" id="L224" title="1 of 2 branches missed.">            } else if(key.startsWith(&quot;weight&quot;)) {</span>
<span class="nc" id="L225">                int dot = key.indexOf('.');</span>
<span class="nc" id="L226">                long sid = Long.parseLong(key.substring(dot + 1));</span>
<span class="nc" id="L227">                serverWeight.put(sid, Long.parseLong(value));</span>
<span class="nc" id="L228">            } else {</span>
<span class="fc" id="L229">                System.setProperty(&quot;zookeeper.&quot; + key, value);</span>
            }
<span class="fc" id="L231">        }</span>
        
        // Reset to MIN_SNAP_RETAIN_COUNT if invalid (less than 3)
        // PurgeTxnLog.purge(File, File, int) will not allow to purge less
        // than 3.
<span class="pc bpc" id="L236" title="1 of 2 branches missed.">        if (snapRetainCount &lt; MIN_SNAP_RETAIN_COUNT) {</span>
<span class="nc" id="L237">            LOG.warn(&quot;Invalid autopurge.snapRetainCount: &quot; + snapRetainCount</span>
                    + &quot;. Defaulting to &quot; + MIN_SNAP_RETAIN_COUNT);
<span class="nc" id="L239">            snapRetainCount = MIN_SNAP_RETAIN_COUNT;</span>
        }

<span class="pc bpc" id="L242" title="1 of 2 branches missed.">        if (dataDir == null) {</span>
<span class="nc" id="L243">            throw new IllegalArgumentException(&quot;dataDir is not set&quot;);</span>
        }
<span class="fc bfc" id="L245" title="All 2 branches covered.">        if (dataLogDir == null) {</span>
<span class="fc" id="L246">            dataLogDir = dataDir;</span>
        }
<span class="pc bpc" id="L248" title="1 of 2 branches missed.">        if (clientPort == 0) {</span>
<span class="nc" id="L249">            throw new IllegalArgumentException(&quot;clientPort is not set&quot;);</span>
        }
<span class="pc bpc" id="L251" title="1 of 2 branches missed.">        if (clientPortAddress != null) {</span>
<span class="nc" id="L252">            this.clientPortAddress = new InetSocketAddress(</span>
<span class="nc" id="L253">                    InetAddress.getByName(clientPortAddress), clientPort);</span>
        } else {
<span class="fc" id="L255">            this.clientPortAddress = new InetSocketAddress(clientPort);</span>
        }

<span class="pc bpc" id="L258" title="1 of 2 branches missed.">        if (tickTime == 0) {</span>
<span class="nc" id="L259">            throw new IllegalArgumentException(&quot;tickTime is not set&quot;);</span>
        }
<span class="pc bpc" id="L261" title="1 of 2 branches missed.">        if (minSessionTimeout &gt; maxSessionTimeout) {</span>
<span class="nc" id="L262">            throw new IllegalArgumentException(</span>
                    &quot;minSessionTimeout must not be larger than maxSessionTimeout&quot;);
        }
<span class="fc bfc" id="L265" title="All 2 branches covered.">        if (servers.size() == 0) {</span>
<span class="fc bfc" id="L266" title="All 2 branches covered.">            if (observers.size() &gt; 0) {</span>
<span class="fc" id="L267">                throw new IllegalArgumentException(&quot;Observers w/o participants is an invalid configuration&quot;);</span>
            }
            // Not a quorum configuration so return immediately - not an error
            // case (for b/w compatibility), server will default to standalone
            // mode.
<span class="fc" id="L272">            return;</span>
<span class="fc bfc" id="L273" title="All 2 branches covered.">        } else if (servers.size() == 1) {</span>
<span class="fc bfc" id="L274" title="All 2 branches covered.">            if (observers.size() &gt; 0) {</span>
<span class="fc" id="L275">                throw new IllegalArgumentException(&quot;Observers w/o quorum is an invalid configuration&quot;);</span>
            }

            // HBase currently adds a single server line to the config, for
            // b/w compatibility reasons we need to keep this here.
<span class="fc" id="L280">            LOG.error(&quot;Invalid configuration, only one server specified (ignoring)&quot;);</span>
<span class="fc" id="L281">            servers.clear();</span>
<span class="pc bpc" id="L282" title="1 of 2 branches missed.">        } else if (servers.size() &gt; 1) {</span>
<span class="fc bfc" id="L283" title="All 2 branches covered.">            if (servers.size() == 2) {</span>
<span class="fc" id="L284">                LOG.warn(&quot;No server failure will be tolerated. &quot; +</span>
                    &quot;You need at least 3 servers.&quot;);
<span class="pc bpc" id="L286" title="1 of 2 branches missed.">            } else if (servers.size() % 2 == 0) {</span>
<span class="nc" id="L287">                LOG.warn(&quot;Non-optimial configuration, consider an odd number of servers.&quot;);</span>
            }
<span class="pc bpc" id="L289" title="1 of 2 branches missed.">            if (initLimit == 0) {</span>
<span class="nc" id="L290">                throw new IllegalArgumentException(&quot;initLimit is not set&quot;);</span>
            }
<span class="pc bpc" id="L292" title="1 of 2 branches missed.">            if (syncLimit == 0) {</span>
<span class="nc" id="L293">                throw new IllegalArgumentException(&quot;syncLimit is not set&quot;);</span>
            }
            /*
             * If using FLE, then every server requires a separate election
             * port.
             */
<span class="pc bpc" id="L299" title="1 of 2 branches missed.">            if (electionAlg != 0) {</span>
<span class="fc bfc" id="L300" title="All 2 branches covered.">                for (QuorumServer s : servers.values()) {</span>
<span class="pc bpc" id="L301" title="1 of 2 branches missed.">                    if (s.electionAddr == null)</span>
<span class="nc" id="L302">                        throw new IllegalArgumentException(</span>
                                &quot;Missing election port for server: &quot; + s.id);
<span class="fc" id="L304">                }</span>
            }

            /*
             * Default of quorum config is majority
             */
<span class="pc bpc" id="L310" title="1 of 2 branches missed.">            if(serverGroup.size() &gt; 0){</span>
<span class="nc bnc" id="L311" title="All 2 branches missed.">                if(servers.size() != serverGroup.size())</span>
<span class="nc" id="L312">                    throw new ConfigException(&quot;Every server must be in exactly one group&quot;);</span>
                /*
                 * The deafult weight of a server is 1
                 */
<span class="nc bnc" id="L316" title="All 2 branches missed.">                for(QuorumServer s : servers.values()){</span>
<span class="nc bnc" id="L317" title="All 2 branches missed.">                    if(!serverWeight.containsKey(s.id))</span>
<span class="nc" id="L318">                        serverWeight.put(s.id, (long) 1);</span>
<span class="nc" id="L319">                }</span>

                /*
                 * Set the quorumVerifier to be QuorumHierarchical
                 */
<span class="nc" id="L324">                quorumVerifier = new QuorumHierarchical(numGroups,</span>
                        serverWeight, serverGroup);
            } else {
                /*
                 * The default QuorumVerifier is QuorumMaj
                 */

<span class="fc" id="L331">                LOG.info(&quot;Defaulting to majority quorums&quot;);</span>
<span class="fc" id="L332">                quorumVerifier = new QuorumMaj(servers.size());</span>
            }

            // Now add observers to servers, once the quorums have been
            // figured out
<span class="fc" id="L337">            servers.putAll(observers);</span>
    
<span class="fc" id="L339">            File myIdFile = new File(dataDir, &quot;myid&quot;);</span>
<span class="pc bpc" id="L340" title="1 of 2 branches missed.">            if (!myIdFile.exists()) {</span>
<span class="nc" id="L341">                throw new IllegalArgumentException(myIdFile.toString()</span>
                        + &quot; file is missing&quot;);
            }
<span class="fc" id="L344">            BufferedReader br = new BufferedReader(new FileReader(myIdFile));</span>
            String myIdString;
            try {
<span class="fc" id="L347">                myIdString = br.readLine();</span>
<span class="fc" id="L348">            } finally {</span>
<span class="nc" id="L349">                br.close();</span>
<span class="fc" id="L350">            }</span>
            try {
<span class="fc" id="L352">                serverId = Long.parseLong(myIdString);</span>
<span class="fc" id="L353">                MDC.put(&quot;myid&quot;, myIdString);</span>
<span class="nc" id="L354">            } catch (NumberFormatException e) {</span>
<span class="nc" id="L355">                throw new IllegalArgumentException(&quot;serverid &quot; + myIdString</span>
                        + &quot; is not a number&quot;);
<span class="fc" id="L357">            }</span>
            
            // Warn about inconsistent peer type
<span class="fc bfc" id="L360" title="All 2 branches covered.">            LearnerType roleByServersList = observers.containsKey(serverId) ? LearnerType.OBSERVER</span>
                    : LearnerType.PARTICIPANT;
<span class="fc bfc" id="L362" title="All 2 branches covered.">            if (roleByServersList != peerType) {</span>
<span class="fc" id="L363">                LOG.warn(&quot;Peer type from servers list (&quot; + roleByServersList</span>
                        + &quot;) doesn't match peerType (&quot; + peerType
                        + &quot;). Defaulting to servers list.&quot;);
    
<span class="fc" id="L367">                peerType = roleByServersList;</span>
            }
        }
<span class="pc" id="L370">    }</span>

<span class="fc" id="L372">    public InetSocketAddress getClientPortAddress() { return clientPortAddress; }</span>
<span class="fc" id="L373">    public String getDataDir() { return dataDir; }</span>
<span class="fc" id="L374">    public String getDataLogDir() { return dataLogDir; }</span>
<span class="fc" id="L375">    public int getTickTime() { return tickTime; }</span>
<span class="fc" id="L376">    public int getMaxClientCnxns() { return maxClientCnxns; }</span>
<span class="fc" id="L377">    public int getMinSessionTimeout() { return minSessionTimeout; }</span>
<span class="fc" id="L378">    public int getMaxSessionTimeout() { return maxSessionTimeout; }</span>

<span class="fc" id="L380">    public int getInitLimit() { return initLimit; }</span>
<span class="fc" id="L381">    public int getSyncLimit() { return syncLimit; }</span>
<span class="fc" id="L382">    public int getElectionAlg() { return electionAlg; }</span>
<span class="nc" id="L383">    public int getElectionPort() { return electionPort; }    </span>
    
    public int getSnapRetainCount() {
<span class="fc" id="L386">        return snapRetainCount;</span>
    }

    public int getPurgeInterval() {
<span class="fc" id="L390">        return purgeInterval;</span>
    }
    
    public boolean getSyncEnabled() {
<span class="fc" id="L394">        return syncEnabled;</span>
    }

    public QuorumVerifier getQuorumVerifier() {   
<span class="fc" id="L398">        return quorumVerifier;</span>
    }

    public Map&lt;Long,QuorumServer&gt; getServers() {
<span class="fc" id="L402">        return Collections.unmodifiableMap(servers);</span>
    }

<span class="fc" id="L405">    public long getServerId() { return serverId; }</span>

<span class="nc bnc" id="L407" title="All 2 branches missed.">    public boolean isDistributed() { return servers.size() &gt; 1; }</span>

    public LearnerType getPeerType() {
<span class="fc" id="L410">        return peerType;</span>
    }

    public Boolean getQuorumListenOnAllIPs() {
<span class="fc" id="L414">        return quorumListenOnAllIPs;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>